﻿using System.Collections.Generic;
using RssReader.Common;

namespace RssReader.FeedProvider
{
    public sealed class Feed : BindableBase
    {
        public Feed()
        {
            Items = new List<Item>();
        }

        private string _title;
        public string Title {
            get { return this._title; }
            set 
            { 
                this.SetProperty(ref this._title, value); 
            }
        }

        private string _url;
        public string Url {
            get
            {
                return _url;
            }
            set
            {
                this.SetProperty(ref this._url, value);
            }
        }

        private string _category;
        public string Category {
            get
            {
                return _category;
            }
            set
            {
                this.SetProperty(ref this._category, value);
            }
        }

        private string _imageSource;
        public string ImageSource
        {
            get
            {
                return _imageSource;
            }
            set
            {
                this.SetProperty(ref this._imageSource, value);
            }
        }

        private IList<Item> _items;
        public IList<Item> Items {
            get
            {
                return _items;
            }
            set
            {
                this.SetProperty(ref this._items, value);
            }
        }

        private int _totalItems;
        public int TotalItems
        {
            get
            {
                return _totalItems;
            }
            set
            {
                this.SetProperty(ref this._totalItems, value);
            }
        }
    }
}
