﻿using Windows.Storage;

namespace RssReader.Storage
{
    public class LocalSettings
    {
        readonly ApplicationDataContainer _localSettings =
                ApplicationData.Current.LocalSettings;

        private const string ItemKey = "clickedItem";

        public void Remove_setting(string settingKey)
        {
            var key = _localSettings.Values[settingKey];
            if (key != null) _localSettings.Values.Remove(settingKey);
        }

        public void Store_value(string settingKey, string value)
        {
            _localSettings.Values[settingKey] = value;
        }

        public void Store_value(string settingKey, object value)
        {
            _localSettings.Values[settingKey] = value;
        }

        public object Get_value(string settingKey)
        {
            return _localSettings.Values[settingKey];
        }

        public string Get_stored_clicked_item_title()
        {
            return (string) _localSettings.Values[ItemKey];
        }

        public void Store_clicked_item_title(string title)
        {
            _localSettings.Values[ItemKey] = title;
        }

        public void Remove_clicked_item_title()
        {
            this.Remove_setting(ItemKey);
        }

        public void Store_composite_value(string settingsKey, ApplicationDataCompositeValue composite)
        {
            _localSettings.Values[settingsKey] = composite;
        }

        public ApplicationDataCompositeValue Get_composite_key_value_pair(string settingsKey)
        {
            var composite = (ApplicationDataCompositeValue)_localSettings.Values[settingsKey];

            return composite;
        }
    }
}
